diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 64e3ddd39..825a17084 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1275,21 +1161,49 @@ public class RenderGlobal
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         GL11.glDisable(GL11.GL_BLEND);
         GL11.glEnable(GL11.GL_CULL_FACE);
-        
-    	mc.renderer.endRenderClouds(partialTick);
+
+        mc.renderer.endRenderClouds(partialTick);
     }
 
-    public boolean updateDirtyChunks(ICamera camera) {
-        final DirtyChunkRendererSorter dirtyChunkRendererSorter = new DirtyChunkRendererSorter(camera);
-        final ChunkRenderer[] toAdd = new ChunkRenderer[MAX_VISIBLE_REBUILDS_PER_FRAME];
-        List<ChunkRenderer> nearChunks = null;
+    private final DirtyChunkRendererSorter dirtyChunkRendererSorter = new DirtyChunkRendererSorter();
+//    private final List<@NotNull ChunkRenderer> dirtyChunks2 = new ArrayList<>();
+//    public boolean updateDirtyChunks(@NotNull ICamera camera) {
+//        this.dirtyChunkRendererSorter.setActiveCamera(camera);
+//
+//        this.dirtyChunks2.clear();
+//        this.dirtyChunks2.addAll(this.dirtyChunks);
+//        this.dirtyChunks2.sort(this.dirtyChunkRendererSorter);
+//        int chunksUpdated = 0;
+//        var chunkItr = this.dirtyChunks2.iterator();
+//        while (chunkItr.hasNext() && chunksUpdated <= MAX_VISIBLE_REBUILDS_PER_FRAME) {
+//            var renderer = chunkItr.next();
+//            if (this.cantBuildRenderers.contains(renderer)) continue;
+//            if (renderer.rebuild(renderer.distanceToCameraSquared(camera) < 2048)) {
+//                chunkItr.remove();
+//                renderer.dirty = false;
+//                chunksUpdated++;
+//            } else {
+//                this.cantBuildRenderers.add(renderer);
+//            }
+//        }
+//        this.dirtyChunks.clear();
+//        this.dirtyChunks.addAll(this.dirtyChunks2);
+//
+//        return this.dirtyChunks.size() <= this.cantBuildRenderers.size(); // Return true if no more dirty renderers
+//    }
+
+    private @Nullable ChunkRenderer @NotNull [] toAdd = new ChunkRenderer[MAX_VISIBLE_REBUILDS_PER_FRAME];
+    private @NotNull List<@NotNull ChunkRenderer> nearChunks = new ArrayList<>();
+    public boolean updateDirtyChunks(@NotNull ICamera camera) {
+        dirtyChunkRendererSorter.setActiveCamera(camera);
+        Arrays.fill(toAdd, null);
+        this.nearChunks.clear();
 
         final int pendingChunkSize = dirtyChunks.size();
-        int pendingChunkRemoved = 0;
 
         for(int i = 0; i < pendingChunkSize; i++) {
             final ChunkRenderer renderer = dirtyChunks.get(i);
-            if(renderer.distanceToCameraSquared(camera) > 1024.0f) {
+            if(renderer.distanceToCameraSquared(camera) > 2048f) {
                 int index = 0;
 
                 while (index < MAX_VISIBLE_REBUILDS_PER_FRAME && (toAdd[index] == null || dirtyChunkRendererSorter.compare(toAdd[index], renderer) <= 0)) {
@@ -1308,26 +1222,21 @@ public class RenderGlobal
                 continue;
             }
 
-            if(nearChunks == null) {
-                nearChunks = new ArrayList<>();
-            }
-
-            pendingChunkRemoved++;
             nearChunks.add(renderer);
-            dirtyChunks.set(i, null);
         }
 
-        if(nearChunks != null) {
+        if(!nearChunks.isEmpty()) {
             if(nearChunks.size() > 1) {
                 nearChunks.sort(dirtyChunkRendererSorter);
             }
             for (ChunkRenderer renderer : nearChunks){
-                renderer.rebuild();
-                renderer.dirty = false;
+                if (renderer.rebuild(true)) {
+                    renderer.dirty = false;
+                    dirtyChunks.remove(renderer);
+                }
             }
         }
 
-        int secondaryRemoved = 0;
         for(int i = MAX_VISIBLE_REBUILDS_PER_FRAME - 1; i >= 0; i--) {
             ChunkRenderer chunkx = toAdd[i];
             if(chunkx == null) { continue; }
@@ -1335,43 +1244,21 @@ public class RenderGlobal
                 toAdd[i] = null;
                 break;
             }
-            chunkx.rebuild();
-            chunkx.dirty = false;
-            secondaryRemoved++;
-        }
-
-        int cursor = 0;
-        int target = 0;
-        outer: for (int size = dirtyChunks.size(); cursor != size; cursor++) {
-            final ChunkRenderer renderer = dirtyChunks.get(cursor);
-            if(renderer == null) { continue; }
-            for(int i = 0; i < MAX_VISIBLE_REBUILDS_PER_FRAME; i++) {
-                if (renderer == toAdd[i]) {
-                    continue outer;
-                }
+            if (chunkx.rebuild(false)) {
+                chunkx.dirty = false;
+                dirtyChunks.remove(chunkx);
             }
-
-            if(target != cursor) {
-                dirtyChunks.set(target, renderer);
-            }
-            target++;
-        }
-
-        while(--cursor >= target) {
-            dirtyChunks.remove(cursor);
         }
-        return pendingChunkSize == (pendingChunkRemoved + secondaryRemoved);
+        return dirtyChunks.isEmpty();
     }
 
-    public void drawBlockBreaking(ICamera camera, HitResult hitResult, float partialTick)
-    {
+    public void drawBlockBreaking(ICamera camera, HitResult hitResult, float partialTick) {
         Tessellator tessellator = Tessellator.instance;
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glEnable(GL11.GL_ALPHA_TEST);
         GL11.glBlendFunc(770, 1);
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, (MathHelper.sin((float)System.currentTimeMillis() / 100F) * 0.2F + 0.4F) * 0.5F);
-        if(destroyProgress > 0.0F)
-        {
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, (MathHelper.sin((float) System.currentTimeMillis() / 100F) * 0.2F + 0.4F) * 0.5F);
+        if (destroyProgress > 0.0F) {
             GL11.glBlendFunc(774, 768);
             TextureRegistry.blockAtlas.bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 0.5F);
@@ -1384,17 +1271,16 @@ public class RenderGlobal
             double x = camera.getX(partialTick);
             double y = camera.getY(partialTick);
             double z = camera.getZ(partialTick);
-            if(block == null)
-            {
+            if (block == null) {
                 block = Blocks.STONE;
             }
             GL11.glEnable(GL11.GL_ALPHA_TEST);
             tessellator.startDrawingQuads();
             tessellator.setTranslation(-x, -y, -z);
             tessellator.lockColor();
-            if(LightmapHelper.isLightmapEnabled()) {
-            	// Make sure it's active to prevent crash if a model doesnt enable it
-            	tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 0));
+            if (LightmapHelper.isLightmapEnabled()) {
+                // Make sure it's active to prevent crash if a model doesnt enable it
+                tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 0));
             }
             BlockModelDispatcher.getInstance()
                 .getDispatch(block)
@@ -1404,7 +1290,7 @@ public class RenderGlobal
                     hitResult.x,
                     hitResult.y,
                     hitResult.z,
-                    breakingAnimation[MathHelper.clamp((int)(destroyProgress * 10F), 0, breakingAnimation.length - 1)]);
+                    breakingAnimation[MathHelper.clamp((int) (destroyProgress * 10F), 0, breakingAnimation.length - 1)]);
             tessellator.draw();
             tessellator.setTranslation(0.0D, 0.0D, 0.0D);
             GL11.glDisable(GL11.GL_ALPHA_TEST);
@@ -1418,10 +1304,8 @@ public class RenderGlobal
         GL11.glDisable(GL11.GL_ALPHA_TEST);
     }
 
-    public void drawSelectionBox(ICamera camera, HitResult hitResult, float partialTick)
-    {
-        if (mc.gameSettings.immersiveMode.drawOutline() && mc.gameSettings.blockOutlineWidth.value > 0.01f && !(mc.currentScreen instanceof ScreenModelViewer))
-        {
+    public void drawSelectionBox(ICamera camera, HitResult hitResult, float partialTick) {
+        if (mc.gameSettings.immersiveMode.drawOutline() && mc.gameSettings.blockOutlineWidth.value > 0.01f && !(mc.currentScreen instanceof ScreenModelViewer)) {
             GL11.glEnable(GL11.GL_BLEND);
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
             float w = mc.getOutlineWidth();
@@ -1433,19 +1317,14 @@ public class RenderGlobal
             double offsetY = camera.getY(partialTick);
             double offsetZ = camera.getZ(partialTick);
 
-            if(hitResult.hitType == HitResult.HitType.TILE)
-            {
+            if (hitResult.hitType == HitResult.HitType.TILE) {
                 float expand = 0.002F;
                 Block<?> block = world.getBlock(hitResult.x, hitResult.y, hitResult.z);
-                if(block != null)
-                {
+                if (block != null) {
                     BoundingVolume volume = block.getBoundingVolume(world, hitResult.x, hitResult.y, hitResult.z);
-                    if (volume != null)
-                    {
+                    if (volume != null) {
                         drawOutlinedVolume(volume, hitResult.x - offsetX, hitResult.y - offsetY, hitResult.z - offsetZ, expand);
-                    }
-                    else
-                    {
+                    } else {
                         drawOutlinedBoundingBox(block.getSelectedBoundingBoxFromPool(world, hitResult.x, hitResult.y, hitResult.z).grow(expand, expand, expand).cloneMove(-offsetX, -offsetY, -offsetZ));
                     }
                     if (mc.gameSettings.viewSupportMode.value) {
@@ -1782,9 +1661,7 @@ public class RenderGlobal
                         t.draw();
                     }
                 }
-            }
-            else if (hitResult.hitType == HitResult.HitType.ENTITY && hitResult.entity.showBoundingBoxOnHover() && !mc.gameSettings.showCollisionBoxes.value)
-            {
+            } else if (hitResult.hitType == HitResult.HitType.ENTITY && hitResult.entity.showBoundingBoxOnHover() && !mc.gameSettings.showCollisionBoxes.value) {
                 drawInterpolatedEntityBoundingBox(hitResult.entity, hitResult.entity.bb, camera, partialTick);
             }
 
@@ -1793,26 +1670,26 @@ public class RenderGlobal
             GL11.glDisable(GL11.GL_BLEND);
         }
     }
-    
+
     public void drawDebugEntityOutlines(ICamera camera, float partialTicks) {
-		glDisable(GL_TEXTURE_2D);
-		glLineWidth(2.0f);
-		
-		double offsetX = camera.getX(partialTicks);
-		double offsetY = camera.getY(partialTicks);
-		double offsetZ = camera.getZ(partialTicks);
-		float expand = 0.002F;
-		List<AABB> collidingBoundingBoxes = world.getCubes(mc.thePlayer, mc.thePlayer.bb.grow(expand, expand, expand));
+        glDisable(GL_TEXTURE_2D);
+        glLineWidth(2.0f);
+
+        double offsetX = camera.getX(partialTicks);
+        double offsetY = camera.getY(partialTicks);
+        double offsetZ = camera.getZ(partialTicks);
+        float expand = 0.002F;
+        List<AABB> collidingBoundingBoxes = world.getCubes(mc.thePlayer, mc.thePlayer.bb.grow(expand, expand, expand));
         glColor4f(0.0f, 0.0f, 1.0f, 1.0f);
-		for (AABB aabb : collidingBoundingBoxes) {
-			drawOutlinedBoundingBox(aabb.cloneMove(-offsetX, -offsetY, -offsetZ).grow(expand, expand, expand));
-		}
-
-		float entityRadius = 10.0f;
-		if(mc.thePlayer.getGamemode() == Gamemode.creative) {
-			entityRadius = 100.0f;
-		}
-		List<Entity> entitiesNearby = world.getEntitiesWithinAABBExcludingEntity(null, mc.thePlayer.bb.grow(entityRadius, entityRadius, entityRadius));
+        for (AABB aabb : collidingBoundingBoxes) {
+            drawOutlinedBoundingBox(aabb.cloneMove(-offsetX, -offsetY, -offsetZ).grow(expand, expand, expand));
+        }
+
+        float entityRadius = 10.0f;
+        if (mc.thePlayer.getGamemode() == Gamemode.creative) {
+            entityRadius = 100.0f;
+        }
+        List<Entity> entitiesNearby = world.getEntitiesWithinAABBExcludingEntity(null, mc.thePlayer.bb.grow(entityRadius, entityRadius, entityRadius));
         for (Entity e : entitiesNearby) {
             glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
             drawInterpolatedEntityBoundingBox(e, e.bb, camera, partialTicks); // Bounds
@@ -1836,11 +1713,11 @@ public class RenderGlobal
             glDisable(GL_TEXTURE_2D);
             GL11.glLineWidth(2);
         }
-		
-		glEnable(GL_TEXTURE_2D);
-	}
 
-    public static void drawDebugVec(final Tessellator tessellator, final Vec3 pos, final Vec3 vec, final double scale, final float r, final float g, final float b, final float a){
+        glEnable(GL_TEXTURE_2D);
+    }
+
+    public static void drawDebugVec(final Tessellator tessellator, final Vec3 pos, final Vec3 vec, final double scale, final float r, final float g, final float b, final float a) {
         if (pos == null || vec == null) return;
         GL11.glLineWidth(10);
         GL11.glDisable(GL11.GL_TEXTURE_2D);
@@ -1870,96 +1747,95 @@ public class RenderGlobal
         drawOutlinedBoundingBox(boundingBox);
     }
 
-	public void drawDebugChunkBorders(ICamera camera, float partialTicks) {
-		glDisable(GL_TEXTURE_2D);
-		glDisable(GL_FOG);
-
-		double offsetX = camera.getX(partialTicks);
-		double offsetY = camera.getY(partialTicks);
-		double offsetZ = camera.getZ(partialTicks);
-		
-		Tessellator tessellator = Tessellator.instance;
-		tessellator.setTranslation(-offsetX, -offsetY, -offsetZ);
-		
-		int blockX = MathHelper.floor(mc.thePlayer.x);
-		int blockZ = MathHelper.floor(mc.thePlayer.z);
-
-		int chunkX = blockX >> 4;
+    public void drawDebugChunkBorders(ICamera camera, float partialTicks) {
+        glDisable(GL_TEXTURE_2D);
+        glDisable(GL_FOG);
+
+        double offsetX = camera.getX(partialTicks);
+        double offsetY = camera.getY(partialTicks);
+        double offsetZ = camera.getZ(partialTicks);
+
+        Tessellator tessellator = Tessellator.instance;
+        tessellator.setTranslation(-offsetX, -offsetY, -offsetZ);
+
+        int blockX = MathHelper.floor(mc.thePlayer.x);
+        int blockZ = MathHelper.floor(mc.thePlayer.z);
+
+        int chunkX = blockX >> 4;
         int chunkZ = blockZ >> 4;
-        
+
         int x0 = chunkX << 4;
         int z0 = chunkZ << 4;
-        
-		int x1 = x0 + 16;
-		int z1 = z0 + 16;
-		
-		int worldHeight = mc.currentWorld.getHeightBlocks();
 
-		glLineWidth(2.0f);
+        int x1 = x0 + 16;
+        int z1 = z0 + 16;
+
+        int worldHeight = mc.currentWorld.getHeightBlocks();
+
+        glLineWidth(2.0f);
         glColor4f(1.0f, 0.0f, 0.0f, 1.0f);
         tessellator.startDrawing(GL_LINES);
 
-		// Draw vertical red lines
-		for(int i = -1; i <= 2; i++) {
-			for(int j = -1; j <= 2; j++) {
-				int x2 = (chunkX + i) << 4;
-				int z2 = (chunkZ + j) << 4;
-				
-				tessellator.addVertex(x2, 0, z2);
-				tessellator.addVertex(x2, worldHeight, z2);
-			}
-		}
-
-		tessellator.draw();
-		
-		glLineWidth(1.0f);
-		glColor4f(0.0f, 1.0f, 0.0f, 1.0f);
+        // Draw vertical red lines
+        for (int i = -1; i <= 2; i++) {
+            for (int j = -1; j <= 2; j++) {
+                int x2 = (chunkX + i) << 4;
+                int z2 = (chunkZ + j) << 4;
+
+                tessellator.addVertex(x2, 0, z2);
+                tessellator.addVertex(x2, worldHeight, z2);
+            }
+        }
+
+        tessellator.draw();
+
+        glLineWidth(1.0f);
+        glColor4f(0.0f, 1.0f, 0.0f, 1.0f);
         tessellator.startDrawing(GL_LINES);
-		
-		// Draw horizontal green lines
-		for(int y=0; y <= worldHeight; y++) {
-			if(y % 2 == 1) continue;
-			
-			tessellator.addVertex(x0, y, z0);
-			tessellator.addVertex(x1, y, z0);
-			
-			tessellator.addVertex(x0, y, z1);
-			tessellator.addVertex(x1, y, z1);
-			
-			tessellator.addVertex(x0, y, z0);
-			tessellator.addVertex(x0, y, z1);
-			
-			tessellator.addVertex(x1, y, z0);
-			tessellator.addVertex(x1, y, z1);
-		}
-		
-		for(int i = 1; i < 16; i++) {
-			if(i % 2 == 1) continue;
-			
-			tessellator.addVertex(x0 + i, 0, z0);
-			tessellator.addVertex(x0 + i, 256, z0);
-			
-			tessellator.addVertex(x0, 0, z0 + i);
-			tessellator.addVertex(x0, 256, z0 + i);
-			
-			tessellator.addVertex(x0 + i, 0, z1);
-			tessellator.addVertex(x0 + i, 256, z1);
-			
-			tessellator.addVertex(x1, 0, z0 + i);
-			tessellator.addVertex(x1, 256, z0 + i);
-		}
-		
-		// Draw vertical green lines
-		
-		tessellator.draw();
-		
-		tessellator.setTranslation(0.0, 0.0, 0.0);
-		glEnable(GL_TEXTURE_2D);
-		glEnable(GL_FOG);
-	}
-
-    public void drawOutlinedBoundingBox(AABB aabb)
-    {
+
+        // Draw horizontal green lines
+        for (int y = 0; y <= worldHeight; y++) {
+            if (y % 2 == 1) continue;
+
+            tessellator.addVertex(x0, y, z0);
+            tessellator.addVertex(x1, y, z0);
+
+            tessellator.addVertex(x0, y, z1);
+            tessellator.addVertex(x1, y, z1);
+
+            tessellator.addVertex(x0, y, z0);
+            tessellator.addVertex(x0, y, z1);
+
+            tessellator.addVertex(x1, y, z0);
+            tessellator.addVertex(x1, y, z1);
+        }
+
+        for (int i = 1; i < 16; i++) {
+            if (i % 2 == 1) continue;
+
+            tessellator.addVertex(x0 + i, 0, z0);
+            tessellator.addVertex(x0 + i, 256, z0);
+
+            tessellator.addVertex(x0, 0, z0 + i);
+            tessellator.addVertex(x0, 256, z0 + i);
+
+            tessellator.addVertex(x0 + i, 0, z1);
+            tessellator.addVertex(x0 + i, 256, z1);
+
+            tessellator.addVertex(x1, 0, z0 + i);
+            tessellator.addVertex(x1, 256, z0 + i);
+        }
+
+        // Draw vertical green lines
+
+        tessellator.draw();
+
+        tessellator.setTranslation(0.0, 0.0, 0.0);
+        glEnable(GL_TEXTURE_2D);
+        glEnable(GL_FOG);
+    }
+
+    public void drawOutlinedBoundingBox(AABB aabb) {
         Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawing(GL11.GL_LINE_STRIP);
         tessellator.addVertex(aabb.minX, aabb.minY, aabb.minZ);
@@ -1987,13 +1863,11 @@ public class RenderGlobal
         tessellator.draw();
     }
 
-    public void drawOutlinedVolume(BoundingVolume volume, double xOffset, double yOffset, double zOffset, float expand)
-    {
+    public void drawOutlinedVolume(BoundingVolume volume, double xOffset, double yOffset, double zOffset, float expand) {
         Tessellator t = Tessellator.instance;
         t.startDrawing(GL11.GL_LINES);
         Float[] points = volume.getBakedLineCoords();
-        for (int i = 0; i < points.length; i += 3)
-        {
+        for (int i = 0; i < points.length; i += 3) {
             float expand0 = ((points[i] - 0.5f) * 2) * expand;
             float expand1 = ((points[i + 1] - 0.5f) * 2) * expand;
             float expand2 = ((points[i + 2] - 0.5f) * 2) * expand;
@@ -2002,40 +1876,32 @@ public class RenderGlobal
         t.draw();
     }
 
-    public void setDirty(int x0, int y0, int z0, int x1, int y1, int z1)
-    {
+    public void setDirty(int x0, int y0, int z0, int x1, int y1, int z1) {
         int _x0 = MathHelper.bucketInt(x0, RENDER_CHUNK_SIZE);
         int _y0 = MathHelper.bucketInt(y0, RENDER_CHUNK_SIZE);
         int _z0 = MathHelper.bucketInt(z0, RENDER_CHUNK_SIZE);
         int _x1 = MathHelper.bucketInt(x1, RENDER_CHUNK_SIZE);
         int _y1 = MathHelper.bucketInt(y1, RENDER_CHUNK_SIZE);
         int _z1 = MathHelper.bucketInt(z1, RENDER_CHUNK_SIZE);
-        for(int x = _x0; x <= _x1; x++)
-        {
+        for (int x = _x0; x <= _x1; x++) {
             int xx = x % xChunks;
-            if(xx < 0)
-            {
+            if (xx < 0) {
                 xx += xChunks;
             }
-            for(int y = _y0; y <= _y1; y++)
-            {
+            for (int y = _y0; y <= _y1; y++) {
                 int yy = y % yChunks;
-                if(yy < 0)
-                {
+                if (yy < 0) {
                     yy += yChunks;
                 }
-                for(int z = _z0; z <= _z1; z++)
-                {
+                for (int z = _z0; z <= _z1; z++) {
                     int zz = z % zChunks;
-                    if(zz < 0)
-                    {
+                    if (zz < 0) {
                         zz += zChunks;
                     }
                     int p = (zz * yChunks + yy) * xChunks + xx;
 
                     ChunkRenderer renderer = chunkRenderers[p];
-                    if(!renderer.dirty)
-                    {
+                    if (!renderer.dirty) {
                         dirtyChunks.add(renderer);
                         renderer.setDirty();
                     }
@@ -2045,23 +1911,18 @@ public class RenderGlobal
     }
 
     @Override
-    public void blockChanged(int x, int y, int z)
-    {
+    public void blockChanged(int x, int y, int z) {
         setDirty(x - 1, y - 1, z - 1, x + 1, y + 1, z + 1);
     }
 
     @Override
-    public void setBlocksDirty(int x0, int y0, int z0, int x1, int y1, int z1)
-    {
+    public void setBlocksDirty(int x0, int y0, int z0, int x1, int y1, int z1) {
         setDirty(x0 - 1, y0 - 1, z0 - 1, x1 + 1, y1 + 1, z1 + 1);
     }
 
-    public void cull(CameraFrustum frustum, float partialTick)
-    {
-        for(int i = 0; i < chunkRenderers.length; i++)
-        {
-            if(!chunkRenderers[i].isEmpty() && (!chunkRenderers[i].visible || (i + cullStep & 0xf) == 0))
-            {
+    public void cull(CameraFrustum frustum, float partialTick) {
+        for (int i = 0; i < chunkRenderers.length; i++) {
+            if (!chunkRenderers[i].isEmpty() && (!chunkRenderers[i].visible || (i + cullStep & 0xf) == 0)) {
                 chunkRenderers[i].cull(frustum, partialTick);
             }
         }
@@ -2070,11 +1931,9 @@ public class RenderGlobal
     }
 
     @Override
-	public void playStreamingMusic(String soundPath, String author, int x, int y, int z)
-    {
-        if(soundPath != null)
-        {
-            if (author != null && !author.isEmpty()){
+    public void playStreamingMusic(String soundPath, String author, int x, int y, int z) {
+        if (soundPath != null) {
+            if (author != null && !author.isEmpty()) {
                 mc.hudIngame.setRecordPlayingMessage(author + " - " + I18n.getInstance().translateKey(soundPath));
             } else {
                 mc.hudIngame.setRecordPlayingMessage(I18n.getInstance().translateKey(soundPath));
@@ -2084,69 +1943,63 @@ public class RenderGlobal
     }
 
     @Override
-	public void playSound(Entity player, String soundPath, SoundCategory category, double x, double y, double z,
-                          float volume, float pitch)
-    {
-        mc.sndManager.playSoundAt(soundPath, category, (float)x, (float)y, (float)z, volume, pitch);
+    public void playSound(Entity player, String soundPath, SoundCategory category, double x, double y, double z,
+                          float volume, float pitch) {
+        mc.sndManager.playSoundAt(soundPath, category, (float) x, (float) y, (float) z, volume, pitch);
     }
-    
+
     @Override
-	public void addParticle(String particleKey, double x, double y, double z, double motionX, double motionY, double motionZ, int data)
-    {
+    public void addParticle(String particleKey, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
         addParticle(particleKey, x, y, z, motionX, motionY, motionZ, data, 16D);
     }
 
     @Override
-	public void addParticle(String particleId, double x, double y, double z,
-                            double motionX, double motionY, double motionZ, int data, double maxDistance)
-    {
-        if(mc == null || mc.activeCamera == null || mc.particleEngine == null) {
+    public void addParticle(String particleId, double x, double y, double z,
+                            double motionX, double motionY, double motionZ, int data, double maxDistance) {
+        if (mc == null || mc.activeCamera == null || mc.particleEngine == null) {
             return;
         }
         double d6 = mc.activeCamera.getX() - x;
         double d7 = mc.activeCamera.getY() - y;
         double d8 = mc.activeCamera.getZ() - z;
-        if(d6 * d6 + d7 * d7 + d8 * d8 > maxDistance * maxDistance)
-        {
+        if (d6 * d6 + d7 * d7 + d8 * d8 > maxDistance * maxDistance) {
             return;
         }
         Particle fx = ParticleDispatcher.getInstance().getDispatch(particleId).newParticle(world, x, y, z, motionX, motionY, motionZ, data);
-        if (fx != null){
+        if (fx != null) {
             mc.particleEngine.add(fx);
         }
     }
-    
-	@Override
-	public void allChanged(boolean lightChanged, boolean seasonChanged) {
-		if(seasonChanged) {
-			Colorizers.update(false);
-		}
-		if(seasonChanged || lightChanged && !LightmapHelper.isLightmapEnabled()) {
-			for(ChunkRenderer chunkRenderer : chunkRenderers) {
-				if(chunkRenderer.skyLit && !chunkRenderer.dirty) {
-					dirtyChunks.add(chunkRenderer);
-					chunkRenderer.setDirty();
-				}
-			}
-		}
-	}
 
     @Override
-    public void tileEntityChanged(int x, int y, int z, TileEntity tileEntity)
-    {
+    public void allChanged(boolean lightChanged, boolean seasonChanged) {
+        if (seasonChanged) {
+            Colorizers.update(false);
+        }
+        if (seasonChanged || lightChanged && !LightmapHelper.isLightmapEnabled()) {
+            for (ChunkRenderer chunkRenderer : chunkRenderers) {
+                if (chunkRenderer.skyLit && !chunkRenderer.dirty) {
+                    dirtyChunks.add(chunkRenderer);
+                    chunkRenderer.setDirty();
+                }
+            }
+        }
+    }
+
+    @Override
+    public void tileEntityChanged(int x, int y, int z, TileEntity tileEntity) {
     }
 
-    public void deleteChunkLists()
-    {
+    public void deleteChunkLists() {
         if (chunkLists >= 0) {
             GLAllocation.deleteDisplayList(chunkLists);
         }
     }
+
     @Override
-    public void levelEvent(@Nullable Player player, int id, int x, int y, int z, int data)
-    {
+    public void levelEvent(@Nullable Player player, int id, int x, int y, int z, int data) {
         Random random = world.rand;
-        switch(id) {
+        switch (id) {
             default:
                 break;
 
